// *File: div0.c
//
// *Oneliner:
// Q/D patch for Clipper exe only with Divide by 0 error on startup
//
// *Description:
//
// After legal bullsh*t finds the loop responsible and then changes the
// divide operation to 2 NOP instructions.  Therefore timing will be
// inaccurate.  YOU AT YOUR OWN RISK!  Based on a comp.lang.clipper post
// attached as hack.txt.
//
// *Make:
//
// This stuff is made for MSC.  Build as: cl /AT /G3 /O1 div0.c
//
//
// *Changelog:
//
// 2001.06.17 12:00GMT WW
//   Initial version.
//
// * Todo:
//   - Add error handling for f functions (macro?).
//   - Make wararg errmsg.


#include <stdio.h>
#include <conio.h>

//---------------------------------------------------------------------

void copyright(void) {
   fprintf( stderr, "Copyleft (C) 2001 Free Software.\n"
                    "Clipper Divide by 0 patch\n"
                    "USE AT YOUR OWN RISK!\n\n");
}

//---------------------------------------------------------------------

void usage( const char *n) {
   fprintf( stderr, "Usage:\n");
   fprintf( stderr, "   %s <progname>\n", n);
   fprintf( stderr,
       "      progname - the name of the Clipper executable.\n\n");
}

//---------------------------------------------------------------------

int agree( const char *n) {
   int ans;

   fprintf( stderr, "You *MUST* backup the Clipper executable %s\n", n);
   fprintf( stderr, "before applying this patch.\n");
   fprintf( stderr, "Have you done this?(Y/N)\nN\r");
   ans = getch();
   if ((ans != 'y') && (ans != 'Y')) {
       fprintf( stderr, "Do the backup and then try again!\n");
       return 0;
   }

   fprintf( stderr, "\n\nYou run this patch on your own risk!\n", n);
   fprintf( stderr, "Don't use if you have the sources!!!\n");
   fprintf( stderr, "After applying the patch the programs timing\n");
   fprintf( stderr, "using CA-Tools timers may not be accurate!\n");
   fprintf( stderr, "The creator of this patch takes no responsibility\n");
   fprintf( stderr, "of any kind regarding anything in any way connected\n");
   fprintf( stderr, "to this patch. You take all responibilities.\n");
   fprintf( stderr, "Do you agree to this?(Y/N)\nN\r");
   ans = getch();
   if ((ans != 'y') && (ans != 'Y')) {
       fprintf( stderr, "Sorry. The don't use this patch!\n");
       return 0;
   }
   fprintf( stderr, "Do you agree you take all responsibilities?(Y/N)\nN\r");
   ans = getch();
   if ((ans != 'y') && (ans != 'Y')) {
       fprintf( stderr, "Sorry. The don't use this patch!\n");
       return 0;
   }

   return 1;

}

//---------------------------------------------------------------------

void doPatch( const char *fn) {
   const char * cgFindBuff = "\xB8\x52\x17\x8B\xCA\x33\xD2\xF7\xF1";
   const size_t cgChgOffs = 7;
   const char * cgChgBuff = "\x90\x90";

   FILE *fh;
   char ch;
   long start = -1;
   size_t hitpos = 0;

   fh = fopen( fn,  "r+b");

   if (!fh) {
      fprintf( stderr, "Error opening %s.  Bailing out.\n\n", fn);
      exit(1);
   }

   while( !feof(fh)) {
      ch = getc( fh);

      if (start != -1) {
        if (!cgFindBuff[hitpos]) {
           printf( "Loop found at 0x%lX.  Applying patch...\n", start);
           fseek( fh, start+cgChgOffs, SEEK_SET);
           fwrite( cgChgBuff, strlen(cgChgBuff), 1, fh);
           fclose(fh);
           printf( "Done.\n\n");
           return;
        }

        if (ch == cgFindBuff[hitpos]) {
           hitpos++;
        } else {
           start=-1;
           hitpos=0;
        }
      }

      if (start == -1) {
        if (ch == cgFindBuff[hitpos]) {
           start = ftell(fh)-1;
           hitpos++;
        }
      }
   }
   fprintf( stderr, "Sorry, could not find loop in %s\n", fn);
   fprintf( stderr, "Patching is *NOT* done!\n\n");
}

//---------------------------------------------------------------------

int main( int argc, char **argv) {

   copyright();

   if (argc !=2) {
      usage( *argv);
      exit(1);
   }

   if (!agree( argv[1])) {
      exit(1);
   }

   fprintf( stderr, "\n\n");

   doPatch( argv[1]);

   return 0;
}